<template>
	<div id="app">
		<header>
			<span>Handling Ajax Request with Axios in Vue</span>
		</header>
		<main>
			<h2>Trending on Giphy</h2>
			<div class="wrapper">
				<div class="wrapper" style="margin-top: 50px;">
					<b-container>
						<b-row>
							<b-col xs="12" sm="6" md="4" lg="3" v-for="trending in trendings" :key="trending.id">
								<div>
									<iframe :data-id="trending.id" :src="trending.embed_url" width="100%" height="100%" frameBorder="0" class="giphy-embed" allowFullScreen></iframe>
									<p><a :href="trending.url" target="_blank">Ir a Giphy</a></p>
									<p>Fecha de creación: {{ trending.import_datetime }}</p>
								</div>
							</b-col>
						</b-row>
					</b-container>
				</div>
			</div>
			<b-container class="bv-example-row">
				<b-row>
					<b-col md="6" offset-md="3">
						<b-form @submit="onSubmit">
							<div>
								<b-form-group id="search_group" label="Buscar Gif's" label-for="input_search" description="Ingrese el término de búsqueda, se mostrarán los primeros 25 resultados">
									<b-form-input id="input_search" type="search" v-model="searchString" required placeholder="Ingrese su busqueda"/>
								</b-form-group>
								<!--<div class="mt-2">Value: {{ searchString}}</div>-->
								<button id="btn" class="" type="submit" variant="primary">Buscar</button>
							</div>
						</b-form>
					</b-col>
				</b-row>
			</b-container>
			<div v-if="loading">
				<!--<img src="../src/assets/loader.gif"/>-->
				Loading.....
			</div>
			<div class="wrapper">
				<div class="wrapper" style="margin-top: 50px;">
					<b-container>
						<b-row>
							<b-col xs="12" sm="6" md="4" lg="3" v-for="giphy in giphys" :key="giphy.id">
								<div>
									<iframe :data-id="giphy.id" :src="giphy.embed_url" width="100%" height="100%" frameBorder="0" class="giphy-embed" allowFullScreen></iframe>
									<p><a :href="giphy.url" target="_blank">Ir a Giphy</a></p>
									<p><small>Fecha de creación: {{ giphy.import_datetime}}</small></p>
								</div>
							</b-col>
						</b-row>
					</b-container>
				</div>
			</div>
		</main>
	</div>
</template>
<script>
	import axios from 'axios';

	export default {
		name: 'app',
		data() {
			return {
				giphys: [],
				trendings: [],
				searchString: "",
				loading: false
			}
		},
		created: function () {
			this.getTrending();
		},
		methods: {
			onSubmit(evt) {
				evt.preventDefault();
				this.getData();
			},
			getTrending: function () {
				console.log("entro")
				axios.get("https://api.giphy.com/v1/gifs/trending", {
					params: {
						api_key: 'jN9QeT4ufM6DbdgV8WSbCwgceYz3mP1F',
						limit: 4,
						rating: "G",
						lang: "en"
					}
				}, {headers: {'Access-Control-Allow-Origin': '*'}})
					.then((response) => {
						console.log(response);
						this.trendings = response.data.data;
					}, (err) => {
						this.loading = false;
					})
			},
			getData: function () {
				this.loading = true;
				axios.get("https://api.giphy.com/v1/gifs/search", {
					params: {
						api_key: 'jN9QeT4ufM6DbdgV8WSbCwgceYz3mP1F',
						q: this.searchString,
						limit: 25,
						offset: 0,
						rating: "G",
						lang: "en"
					}
				}, {headers: {'Access-Control-Allow-Origin': '*'}})
					.then((response) => {
						this.loading = false;
						this.giphys = response.data.data;
					}, (err) => {
						console.log(err);
						this.loading = false;
					})
			}
		},
	}
</script>
<style scoped>
	body {
		margin: 0;
	}
	#app {
		font-family: 'Avenir', Helvetica, Arial, sans-serif;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		color: #2C3E50;
	}
	main {
		text-align: center;
		margin-top: 40px;
	}
	header {
		margin: 0;
		height: 56px;
		padding: 0 16px 0 24px;
		background-color: #35495E;
		color: #FFFFFF;
	}
	header span {
		display: block;
		position: relative;
		font-size: 20px;
		line-height: 1;
		letter-spacing: .02em;
		font-weight: 400;
		box-sizing: border-box;
		padding-top: 16px;
	}
	button {
		background: #51B767;
		color: #FFFFFF;
		padding: 15px;
		border-radius: 0;
		font-weight: bold;
		font-size: 15px;
		border: 0;
	}
	.cards {
		background: #F5F5F5;
		height: 400px;
	}
	.cards:hover {
		transform: translateY(-0.5em);
		background: #EBEBEB;
	}
	.cards {
		column-count: 1;
		column-gap: 1em;
		margin-top: 70px;
	}
</style>